#ifndef EP_INTERCOMM_HPP_INCLUDED
#define EP_INTERCOMM_HPP_INCLUDED

typedef std::pair< int, int > SIZE_RANK_INFO; // < rank, size>
typedef std::vector< std::pair<int, int> > RANK_MAP;  // at(ep_rank) = <ep_rank_local, mpi_rank>
typedef std::map<int, std::pair<int, int> > EP_RANK_MAP;  // key(ep_rank) = <ep_rank_local, mpi_rank>
typedef std::vector<std::pair< std::pair<int, int>, std::pair<int, int> > > INTERCOMM_RANK_MAP;

namespace ep_lib
{

  class ep_comm;

  class ep_intercomm
  {
    public:

    void *mpi_inter_comm;

    RANK_MAP *intercomm_rank_map;
    RANK_MAP *local_rank_map;
    RANK_MAP *remote_rank_map;


    SIZE_RANK_INFO size_rank_info[3];


    ep_comm *local_comm;
    int intercomm_tag;

    ep_intercomm();
    //~ep_intercomm(){delete mpi_inter_comm;}
    bool operator == (ep_intercomm right);
    bool operator != (ep_intercomm right);
    
  };


}



#endif // EP_INTERCOMM_HPP_INCLUDED

