#ifndef EP_REQUEST_HPP_INCLUDED
#define EP_REQUEST_HPP_INCLUDED

#include "ep_comm.hpp"

namespace ep_lib
{
  
  class ep_request
  {
    public:

      void* mpi_request;

      int type;	//! type of the non-blocking communication. 
                // 1: Isend 
                // 2:Irecv 
                // 3:Imrecv 
                // 4:Issend
      int state; // 0: new 
                 // 1: imrecvd
                 // 2: tested or waited
                   
      void* buf;

      int ep_src;
      int ep_tag;
      void* ep_datatype;

      ep_comm *comm;	//! EP communicator related to the communication

      ep_request() {}
      ep_request(void* request);
      bool operator == (ep_request right);
  };
  
  typedef ep_request* MPI_Request;


}



#endif // EP_REQUEST_HPP_INCLUDED

